"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_1 = __importDefault(require("./object"));
function addDiffIndexPrefix(diff, arrayIndexStr) {
    //NOTE: add gaps with length equal the length of prefix
    //'1' => '[0]: 1'
    //'^' => '     ^'
    var marker = diff.marker ? arrayIndexStr.replace(/./g, ' ') + diff.marker : '';
    diff.expected = arrayIndexStr + diff.expected;
    diff.actual = arrayIndexStr + diff.actual;
    diff.marker = marker;
}
function getArraysDiff(err, maxStringLength) {
    var arrayIndexStr = `[${err.key}]: `;
    maxStringLength -= arrayIndexStr.length;
    var diff = object_1.default(err, maxStringLength);
    addDiffIndexPrefix(diff, arrayIndexStr);
    return diff;
}
exports.default = getArraysDiff;
